## tasmanian 8.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

cmake_policy(VERSION 3.19)
project(Tasmanian VERSION 8.2.0 LANGUAGES CXX)
set(Tasmanian_version_comment "") # e.g., " (release candidate)", " (development)", ""
set(Tasmanian_license "BSD 3-Clause with UT-Battelle disclaimer") # used in some headers and python modules (only human readable)

include(GNUInstallDirs) # allows management of install paths

########################################################################
#  User specified options:
#    -D Tasmanian_ENABLE_RECOMMENDED:BOOL=OFF (includes some flags)
#    -D Tasmanian_ENABLE_OPENMP:BOOL=OFF      (recommended)
#    -D Tasmanian_ENABLE_BLAS:BOOL=OFF        (recommended)
#    -D Tasmanian_ENABLE_PYTHON:BOOL=OFF      (recommended)
#    -D Tasmanian_ENABLE_CUDA:BOOL=OFF        (stable)
#    -D Tasmanian_ENABLE_HIP:BOOL=OFF         (stable)
#    -D Tasmanian_ENABLE_DPCPP:BOOL=OFF       (stable)
#    -D Tasmanian_ENABLE_MAGMA:BOOL=OFF       (stable)
#    -D Tasmanian_MATLAB_WORK_FOLDER:PATH=""  (stable)
#    -D Tasmanian_ENABLE_FORTRAN:BOOL=OFF     (stable)
#    -D Tasmanian_ENABLE_MPI:BOOL=OFF         (stable)
#    -D Tasmanian_ENABLE_SWIG:BOOL=OFF        (stable)
#
# Additional options: (if default test behavior is not desired)
#    -D Tasmanian_TESTS_OMP_NUM_THREADS:INT="sets OpenMP number of threads"
#    -D Tasmanian_TESTS_GPU_ID:INT="specifies which GPU to use for testing"
#
# Extra options: (allow for workarounds of bugs and exotic systems)
#    -D Tasmanian_EXTRA_LIBRARIES:STRING="appends more link libraries"
#    -D Tasmanian_EXTRA_INCLUDE_DIRS:LIST="appends more include paths"
#    -D Tasmanian_EXTRA_LINK_DIRS:PATH="appends more link paths"
#
# Selecting specific packages for find_package()
#     -D Python_ROOT_DIR:PATH
#     -D CMAKE_CUDA_COMPILER:PATH
#     -D Tasmanian_MAGMA_ROOT:PATH (or just MAGMA_ROOT)
#     -D MPI_CXX_COMPILER
#     -D MPI_Fortran_COMPILER (must be compatible with the MPI_CXX_COMPILER)
#     -D MPIEXEC_EXECUTABLE   (must be compatible with the MPI_CXX_COMPILER)
#     -D SWIG_EXECUTABLE      (path to swigfortran)
#     (note: swig may require extra includes, use Tasmanian_EXTRA_INCLUDE_DIRS)
#
# Directly specifying libraries and bypassing find_package()
#     -D BLAS_LIBRARIES
#     -D LAPACK_LIBRARIES
#
# Note: directly specifying libraries still requires the corresponding
#       Tasmanian_ENABLE_ option
#
########################################################################

########################################################################
# The build process follows these steps:
# 1. Define all options and assign default values
# 2. Perform sanity check
#    - resolve conflicts, e.g., Python requires shared libs
#    - call find_package() for options that need packages
#    - fail or fallback if find_package() fails for some option
#    - add Tasmanian_dependencies target with all TPLs
# 3. Enable testing and set the master config file
# 4. Add all subdirectories in the correct order
#    - SparseGirds, DREAM, Addons
#    - Interfaces: Python, Fortran, MATLAB
#    - master target and examples
# 5. Install top level files
#    - add the "make test_install" target
#    - cmake export file
#    - master config file
#    - CMakeLists.txt for the examples (include OpenMP hack if needed)
#    - shell (bash) source file that defines paths
# 6. Print final messages
########################################################################

option(BUILD_SHARED_LIBS            "Specify shared or static libraries for Tasmanian"  ON)
option(Tasmanian_ENABLE_RECOMMENDED "Enable (if found) OpenMP, BLAS, and Python, also sets optimization flags" OFF)
option(Tasmanian_ENABLE_OPENMP      "Enable OpenMP support for Tasmanian (recommended)"    OFF)
option(Tasmanian_ENABLE_BLAS        "Enable CPU Blas support for Tasmanian (recommended)"  OFF)
option(Tasmanian_ENABLE_PYTHON      "Enable Python interface for Tasmanian (recommended)"  OFF)
option(Tasmanian_ENABLE_CUDA        "Enable Nvidia CUDA kernels and libraries within Tasmanian (stable)"    OFF)
option(Tasmanian_ENABLE_HIP         "Enable AMD HIP kernels and ROCm libraries within Tasmanian (stable)"   OFF)
option(Tasmanian_ENABLE_DPCPP       "Enable Intel DPC++ kernels and libraries within Tasmanian (stable)"    OFF)
option(Tasmanian_ENABLE_MAGMA       "Enable acceleration using UTK Magma library within Tasmanian (stable)" OFF)
option(Tasmanian_ENABLE_FORTRAN     "Enable Fortran interface for Tasmanian (stable)" OFF)
option(Tasmanian_ENABLE_MPI         "Enable MPI support for Tasmanian (stable)"       OFF)
option(Tasmanian_ENABLE_SWIG        "Regenerate Fortran 2003 bindings with SWIG (developers only)"       OFF)
option(Tasmanian_ENABLE_DOXYGEN     "Enable Doxygen documentation for Tasmanian (complete)" OFF)

if (Tasmanian_ENABLE_FORTRAN90)
    message(FATAL_ERROR "Tasmanian_ENABLE_FORTRAN90 and the Fortran 90 interface have been removed since v8.2")
endif()

# treat those similar to options, but give values other than ON/OFF
set(Tasmanian_MATLAB_WORK_FOLDER     ""  CACHE PATH   "Enable MATLAB interface and use the path for the MATLAB work folder (stable)")

set(Tasmanian_TESTS_GPU_ID          "-1" CACHE STRING "(integer) specify GPU ID for testing, -1 means running tests on all visible devices (optional)")
set(Tasmanian_TESTS_OMP_NUM_THREADS "-1" CACHE STRING "(integer) specify OMP_NUM_THREADS for the tests, if less than 0, this option will be ignored (optional)")

# allow an external project to specify the export variable name
if (${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    set(Tasmanian_export_name "Tasmanian-export")
    enable_testing() # Tasmanian is the main project, enable testing
else()
    set(Tasmanian_export_name "Tasmanian-export" CACHE STRING "Specify the export variable name when merging Tasmanian into an external project")
endif()

if (Tasmanian_ENABLE_CUDA AND NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
    set(CMAKE_CUDA_ARCHITECTURES "OFF" CACHE STRING "CUDA architectures to compile, e.g., -DCMAKE_CUDA_ARCHITECTURES=70;72")
endif()

if (Tasmanian_ENABLE_ROCM) # alias option
    set(Tasmanian_ENABLE_HIP ON)
endif()

########################################################################
# Sanity check, xSDK compatibility, and find_package() calls are all
# done in one place for consistency
# after this call, every enabled option comes with proper found set of
# find_package() provided libraries, includes, etc.
# Also adds Tasmanian_dependencies that links to all dependencies
########################################################################
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/helper_macros.cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/sanity_check_and_xsdk.cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/add_dependencies_target.cmake")


########################################################################
# Core project configuration, passes all options to CXX
########################################################################
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Config/TasmanianConfig.in.hpp"
               "${CMAKE_CURRENT_BINARY_DIR}/configured/TasmanianConfig.hpp")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/configured/TasmanianConfig.hpp"
        DESTINATION include
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
# configure the headers for the logs
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Tasgrid/tasgridLogs.in.hpp" "${CMAKE_CURRENT_BINARY_DIR}/configured/tasgridLogs.hpp")


########################################################################
# Setup targets
# CXX subdirs have to come first, SparseGrids must precede DREAM
# the Addons must come last
# each sub-directory creates a set of targets and links those to
# existing targets (hence the order is important)
# After CXX, the interfaces Fortran, Python, MATLAB can come in any order
# Finally, add the master target to link to all of the above
########################################################################
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/SparseGrids" "${CMAKE_CURRENT_BINARY_DIR}/SparseGrids")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/DREAM"       "${CMAKE_CURRENT_BINARY_DIR}/DREAM")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Addons"      "${CMAKE_CURRENT_BINARY_DIR}/Addons")
add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Tasgrid/"    "${CMAKE_CURRENT_BINARY_DIR}/Tasgrid")

if (Tasmanian_ENABLE_FORTRAN)
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfaceSwig"
                     "${CMAKE_CURRENT_BINARY_DIR}/Fortran03")
endif()

if (Tasmanian_ENABLE_PYTHON)
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfacePython"  "${CMAKE_CURRENT_BINARY_DIR}/Python")
endif()

if (NOT "${Tasmanian_MATLAB_WORK_FOLDER}" STREQUAL "")
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/InterfaceMATLAB"  "${CMAKE_CURRENT_BINARY_DIR}/MATLAB")
endif()

if (Tasmanian_ENABLE_DOXYGEN)
    add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Doxygen"  "${CMAKE_CURRENT_BINARY_DIR}/Doxygen")
endif()

include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/master_targets.cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/all_examples.cmake")


########################################################################
# Tasmanian is merged into an external master project then skip the exports
# The master should be responsible for post-install testing and exporting
########################################################################
if (${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/exports.cmake")
endif()


########################################################################
# Setup Message
########################################################################
include("${CMAKE_CURRENT_SOURCE_DIR}/Config/CMakeIncludes/setup_message.cmake")

=== Makefile ===
#include Config/AltBuildSystems/Makefile.in

# disable openmp on non-Linux platforms
UNAME = $(shell uname)
ifeq ($(UNAME), Linux)
OPENMPFLAGS = -fopenmp
else
OPENMPFLAGS = -Wno-unknown-pragmas
endif

# Default C++ compiler
CC = g++
CXXFLAGS = -O3 -std=c++11 $(OPENMPFLAGS) -fPIC

IADD = -I./include -I./SparseGrids/ -I./InterfaceTPL/ -I./DREAM/ -I./DREAM/Optimization/ -I./Addons/ -I./
LADD = -L./

# set the compile command
COMPILE = $(CC) $(CXXFLAGS) $(IADD) $(LADD)
ECOMPILE = $(CC) $(CXXFLAGS) -I./include

# check if Python exists, disable python with TSG_SKIP_PYTHON=1
ifneq ($(shell echo "import numpy; print(numpy.__version__ )" | python3 2>/dev/null),)
HAS_PYTHON := "Yes"
endif

# object files for each target
SparseGridsObj = \
          ./SparseGrids/tsgIndexSets.o ./SparseGrids/tsgCoreOneDimensional.o ./SparseGrids/tsgIndexManipulator.o ./SparseGrids/tsgGridGlobal.o \
          ./SparseGrids/tsgSequenceOptimizer.o ./SparseGrids/tsgLinearSolvers.o ./SparseGrids/tsgGridSequence.o ./SparseGrids/tsgHardCodedTabulatedRules.o \
          ./SparseGrids/tsgHierarchyManipulator.o ./SparseGrids/tsgGridLocalPolynomial.o ./SparseGrids/tsgRuleWavelet.o ./SparseGrids/tsgGridWavelet.o \
          ./SparseGrids/tsgGridFourier.o ./SparseGrids/tsgDConstructGridGlobal.o ./SparseGrids/tsgAcceleratedDataStructures.o \
          ./SparseGrids/TasmanianSparseGridWrapC.o ./SparseGrids/TasmanianSparseGrid.o ./InterfaceTPL/tsgGpuNull.o

DREAMObj = \
          ./DREAM/tsgDreamState.o ./DREAM/tsgDreamLikelyGaussian.o ./DREAM/tsgDreamSampleWrapC.o \
          ./DREAM/Optimization/tsgParticleSwarm.o ./DREAM/Optimization/tsgGradientDescent.o \
          ./DREAM/Optimization/TasmanianOptimizationWrapC.o

AddonsObj = \
          ./Addons/tsgCLoadNeededValues.o ./Addons/tsgCConstructSurrogate.o ./Addons/tsgCLoadUnstructuredPoints.o ./Addons/tsgCExoticQuadrature.o

TasgridObj = \
          ./Tasgrid/tasgrid_main.o ./SparseGrids/gridtestTestFunctions.o ./SparseGrids/gridtestExternalTests.o ./Tasgrid/tasgridWrapper.o

# test objects
GidtestObj = \
          ./SparseGrids/gridtest_main.o ./SparseGrids/gridtestTestFunctions.o ./SparseGrids/gridtestExternalTests.o \
          ./SparseGrids/gridtestUnitTests.o ./SparseGrids/gridtestTestInterfaceC.o

DREAMTestObj = \
          ./DREAM/dreamtest_main.o ./DREAM/tasdreamExternalTests.o ./DREAM/Optimization/tasdreamOptimizationTests.o

AddonTestObj = \
          ./Addons/testAddons.o

# example objects
SGExampleObj = \
          ./SparseGrids/Examples/example_sparse_grids.o     ./SparseGrids/Examples/example_sparse_grids_01.o \
          ./SparseGrids/Examples/example_sparse_grids_02.o  ./SparseGrids/Examples/example_sparse_grids_03.o \
          ./SparseGrids/Examples/example_sparse_grids_04.o  ./SparseGrids/Examples/example_sparse_grids_05.o \
          ./SparseGrids/Examples/example_sparse_grids_06.o  ./SparseGrids/Examples/example_sparse_grids_07.o \
          ./SparseGrids/Examples/example_sparse_grids_08.o  ./SparseGrids/Examples/example_sparse_grids_09.o \
          ./SparseGrids/Examples/example_sparse_grids_10.o  ./SparseGrids/Examples/example_sparse_grids_11.o

DREAMExampleObj = \
          ./DREAM/Examples/example_dream.o     ./DREAM/Examples/example_dream_01.o \
          ./DREAM/Examples/example_dream_02.o  ./DREAM/Examples/example_dream_03.o \
          ./DREAM/Examples/example_dream_04.o  ./DREAM/Examples/example_dream_05.o

OptExampleObj = \
          ./DREAM/Examples/example_optimization.o     ./DREAM/Examples/example_optimization_01.o \
          ./DREAM/Examples/example_optimization_02.o

# all target
.PHONY: all
all: tasgrid
	@echo ""
	@echo "TASMANIAN Simple GNU Make engine:"
	@echo "Complete build for C/C++, CLI and Python interfaces"
	@echo "MATLAB interface uses 'make matlab'"


# help
.PHONY: help
help:
	@echo "TASMANIAN Simple GNU Make tool"
	@echo " make"
	@echo " make test"
	@echo " make examples"
	@echo " make test_examples"
	@echo " make matlab"


# linear dependence pattern: sparse-grid -> dream -> addons -> python -> tasgrid
tasgrid: Tasmanian.py $(TasgridObj)
	@echo " -- building the tasgrid executable"
	$(COMPILE) $(TasgridObj) $(SparseGridsObj) -o tasgrid

Tasmanian.py: libtasmaniancaddons.so
	@echo " -- building the Python module"
	cp ./InterfacePython/TasmanianConfig.in.py TasmanianConfig.py
	sed -i -e 's|@Tasmanian_VERSION_MAJOR@|'8'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_VERSION_MINOR@|'2'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_license@|'BSD\ 3-Clause\ with\ UT-Battelle\ disclaimer'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_git_hash@|'Tasmanian\ git\ hash\ is\ not\ available\ here'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_libsparsegrid_path@|'`pwd`/libtasmaniansparsegrid.so'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_libdream_path@|'`pwd`/libtasmaniandream.so'|g' ./TasmanianConfig.py
	sed -i -e 's|@Tasmanian_libcaddons_path@|'`pwd`/libtasmaniancaddons.so'|g' ./TasmanianConfig.py
	cp ./InterfacePython/Tasmanian* .

libtasmaniancaddons.so: libtasmaniandream.so $(AddonsObj)
	@echo " -- building the Addons module"
	cp ./Addons/*.hpp ./include/
	$(COMPILE) -shared $(AddonsObj) -o libtasmaniancaddons.so ./libtasmaniandream.so ./libtasmaniansparsegrid.so

libtasmaniandream.so: libtasmaniansparsegrid.so $(DREAMObj)
	@echo " -- building the DREAM module"
	cp ./DREAM/*.hpp ./include/
	cp ./DREAM/Optimization/*.hpp ./include/
	ar rcs libtasmaniandream.a $(DREAMObj)
	$(COMPILE) -shared $(DREAMObj) -o libtasmaniandream.so ./libtasmaniansparsegrid.so

libtasmaniansparsegrid.so: $(SparseGridsObj)
	@echo " -- building the Sparse Grid module"
	cp ./SparseGrids/*.h ./include/
	cp ./SparseGrids/*.hpp ./include/
	ar rcs libtasmaniansparsegrid.a $(SparseGridsObj)
	$(COMPILE) -shared $(SparseGridsObj) -o libtasmaniansparsegrid.so

%.o: %.cpp ./include
	$(COMPILE) -c $< -o $@

include:
	mkdir -p ./include
	cp ./Tasgrid/tasgridLogs.in.hpp ./include/tasgridLogs.hpp
	sed -i '/std/,/endl/d' ./include/tasgridLogs.hpp
	sed -i -e 's|@CMAKE_CURRENT_BINARY_DIR@|'.'|g' ./include/tasgridLogs.hpp
	sed -i -e 's|@Tasmanian_final_install_path@/share/Tasmanian|'.'|g' ./include/tasgridLogs.hpp
	sed -i -e 's|}|'std::cout\<\<\"Unavailable\ without\ CMake\"\<\<std::endl\;\}'|g' ./include/tasgridLogs.hpp
	cp ./Config/AltBuildSystems/TasmanianConfig.hpp ./include/TasmanianConfig.hpp
	cp ./Config/Tasmanian.hpp ./include/


# test target, also compiles the tests
.PHONY: test
test: gridtest dreamtest addontester
	./gridtest
	./dreamtest
	./addontester
ifdef HAS_PYTHON
	cp ./SparseGrids/GaussPattersonRule.table .
	cp ./Config/AltBuildSystems/testConfigureData.py InterfacePython/
	PYTHONPATH=$(PYTHONPATH):./InterfacePython python3 ./InterfacePython/testTSG.py && { echo "SUCCESS: Test completed successfully"; }
else
	@echo "WARNING: Cannot find python3 with numpy in the system path, skipping the Python tests."
endif

addontester: $(AddonTestObj)
	$(COMPILE) $(AddonTestObj) -o addontester libtasmaniansparsegrid.a libtasmaniandream.a

dreamtest: $(DREAMTestObj)
	$(COMPILE) $(DREAMTestObj) -o dreamtest libtasmaniansparsegrid.a libtasmaniandream.a

gridtest: $(GidtestObj)
	$(COMPILE) $(GidtestObj) -o gridtest libtasmaniansparsegrid.a libtasmaniandream.a


# examples
.PHONY: examples
examples: example_sparse_grids example_dream example_optimization
	cp ./InterfacePython/example_sparse_grids.in.py ./InterfacePython/example_sparse_grids.py
	sed -i -e 's|@Tasmanian_string_python_hashbang@|'\/usr\/bin\/env\ python3'|g' ./InterfacePython/example_sparse_grids.py
	sed -i -e 's|@Tasmanian_python_example_import@|'sys.path.append\(\"`pwd`\"\)'|g' ./InterfacePython/example_sparse_grids.py
	cp ./InterfacePython/example_dream.in.py ./InterfacePython/example_dream.py
	sed -i -e 's|@Tasmanian_string_python_hashbang@|'\/usr\/bin\/env\ python3'|g' ./InterfacePython/example_dream.py
	sed -i -e 's|@Tasmanian_python_example_import@|'sys.path.append\(\"`pwd`\"\)'|g' ./InterfacePython/example_dream.py
	cp ./InterfacePython/example_optimization.in.py ./InterfacePython/example_optimization.py
	sed -i -e 's|@Tasmanian_string_python_hashbang@|'\/usr\/bin\/env\ python3'|g' ./InterfacePython/example_optimization.py
	sed -i -e 's|@Tasmanian_python_example_import@|'sys.path.append\(\"`pwd`\"\)'|g' ./InterfacePython/example_optimization.py
	@echo "Compiled the examples, run with the commands"
	@echo "./example_sparse_grids"
	@echo "./example_dream"
	@echo "./example_optimization"
	@echo "python3 ./InterfacePython/example_sparse_grids.py"
	@echo "python3 ./InterfacePython/example_dream.py"
	@echo "python3 ./InterfacePython/example_optimization.py"

example_sparse_grids: $(SGExampleObj)
	$(ECOMPILE) $(SGExampleObj) -o example_sparse_grids ./libtasmaniansparsegrid.a

example_dream: $(DREAMExampleObj)
	$(ECOMPILE) $(DREAMExampleObj) -o example_dream ./libtasmaniansparsegrid.a ./libtasmaniandream.a

example_optimization: $(OptExampleObj)
	$(ECOMPILE) $(OptExampleObj) -o example_optimization ./libtasmaniansparsegrid.a ./libtasmaniandream.a

SparseGrids/Examples/example_sparse_grids%.o: SparseGrids/Examples/example_sparse_grids%.cpp
	$(ECOMPILE) -c $< -o $@

DREAM/Examples/example_dream%.o: DREAM/Examples/example_dream%.cpp
	$(ECOMPILE) -c $< -o $@

DREAM/Examples/example_optimization%.o: DREAM/Examples/example_optimization%.cpp
	$(ECOMPILE) -c $< -o $@

# examples testing
.PHONY: test_examples
test_examples: examples
	./example_sparse_grids
	./example_dream
	./example_optimization
ifdef HAS_PYTHON
	python3 ./InterfacePython/example_sparse_grids.py
	python3 ./InterfacePython/example_dream.py
	python3 ./InterfacePython/example_optimization.py
endif


# Matlab
.PHONY: matlab
matlab:
	cp Config/AltBuildSystems/tsgGetPaths.m InterfaceMATLAB/tsgGetPaths.m
	mkdir -p tsgMatlabWorkFolder
	sed -i -e 's|ENTER\ THE\ PATH\ TO\ MATLAB\ WORK\ FOLDER|'`pwd`/tsgMatlabWorkFolder/'|g' InterfaceMATLAB/tsgGetPaths.m
	sed -i -e 's|ENTER\ THE\ PATH\ TO\ tasgrid\ EXECUTABLE|'`pwd`/tasgrid'|g' InterfaceMATLAB/tsgGetPaths.m
	@echo ""
	@echo "Setting MATLAB work forlder to "`pwd`"/tsgMatlabWorkFolder/"
	@echo "use MATLAB command: addpath('"`pwd`"/InterfaceMATLAB/');"
	@echo ""


# Clean
.PHONY: clean
clean:
	rm -fr libtasmaniansparsegrid.so
	rm -fr libtasmaniansparsegrid.a
	rm -fr libtasmaniandream.so
	rm -fr libtasmaniandream.a
	rm -fr libtasmaniancaddons.so
	rm -fr tasgrid
	rm -fr gridtest
	rm -fr dreamtest
	rm -fr addontester
	rm -fr Tasmanian*.py
	rm -fr *.pyc
	rm -fr GaussPattersonRule.table
	rm -fr __pycache__
	rm -fr ./InterfacePython/__pycache__
	rm -fr ./InterfacePython/*.pyc
	rm -fr ./InterfacePython/example_sparse_grids.py
	rm -fr ./InterfacePython/example_dream.py
	rm -fr ./InterfacePython/example_optimization.py
	rm -fr ./InterfacePython/testConfigureData.py
	rm -fr InterfaceMATLAB/tsgGetPaths.m
	rm -fr example_sparse_grids
	rm -fr example_dream
	rm -fr example_optimization
	rm -fr include
	rm -fr ./SparseGrids/*.o
	rm -fr ./DREAM/*.o
	rm -fr ./DREAM/Optimization/*.o
	rm -fr ./Addons/*.o
	rm -fr ./Tasgrid/*.o
	rm -fr ./InterfaceTPL/*.o
	rm -fr ./SparseGrids/Examples/*.o
	rm -fr ./DREAM/Examples/*.o
	rm -fr ./tsgMatlabWorkFolder
	rm -fr ./testSave
	rm -fr ./refTestFlename.grid

=== Addons/CMakeLists.txt ===
########################################################################
# Addon templates and related tests and interface options
########################################################################

add_library(Tasmanian_addons INTERFACE)

foreach(_tsg_file tsgAddonsCommon.hpp
                  tsgMPIScatterGrid.hpp
                  tsgMPIScatterDream.hpp
                  tsgMPISampleDream.hpp
                  tsgLoadNeededValues.hpp
                  tsgLoadUnstructuredPoints.hpp
                  tsgCandidateManager.hpp
                  tsgConstructSurrogate.hpp
                  tsgMPIConstructGrid.hpp
                  tsgExoticQuadrature.hpp
                  TasmanianAddons.hpp)
    target_sources(Tasmanian_addons INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${_tsg_file}>
                                              $<INSTALL_INTERFACE:${Tasmanian_final_install_path}/include/${_tsg_file}>)
endforeach()

target_include_directories(Tasmanian_addons INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
target_link_libraries(Tasmanian_addons INTERFACE Tasmanian_libdream)

if (Tasmanian_ENABLE_PYTHON) # the C addons are used by Python
    add_library(Tasmanian_caddons SHARED tsgCExoticQuadrature.cpp
                                         tsgCLoadNeededValues.cpp
                                         tsgCConstructSurrogate.cpp
                                         tsgCLoadUnstructuredPoints.cpp)

    target_link_libraries(Tasmanian_caddons Tasmanian_addons)

    set_target_properties(Tasmanian_caddons PROPERTIES OUTPUT_NAME "tasmaniancaddons"
                                                       INSTALL_RPATH "${Tasmanian_rpath}"
                                                       SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                       VERSION   ${PROJECT_VERSION})

    install(TARGETS Tasmanian_caddons EXPORT "${Tasmanian_export_name}")
endif()

# The Tasmanian MPI capabilities are templated into the Addons
if (Tasmanian_ENABLE_MPI)
    target_link_libraries(Tasmanian_addons INTERFACE MPI::MPI_CXX)

    add_executable(Tasmanian_mpitester testMPI.cpp testMPI.hpp testMPIDream.hpp)
    add_test(MPISparseGridsIO ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} 3 ${MPIEXEC_PREFLAGS} ${CMAKE_CURRENT_BINARY_DIR}/mpitester ${MPIEXEC_POSTFLAGS})

    list(APPEND Tasmanian_addons_executables "mpitester")
    list(APPEND Tasmanian_addons_tests "MPISparseGridsIO")
endif()

# test for non-MPI capabilities
add_executable(Tasmanian_addontester testAddons.cpp testConstructSurrogate.hpp testLoadUnstructured.hpp)
add_test(AddonTests addontester -gpuid ${Tasmanian_TESTS_GPU_ID})

list(APPEND Tasmanian_addons_executables "addontester")
list(APPEND Tasmanian_addons_tests "AddonTests")

# set properties for all executable targets
foreach(_tsg_exec ${Tasmanian_addons_executables})
    set_target_properties(Tasmanian_${_tsg_exec} PROPERTIES OUTPUT_NAME "${_tsg_exec}" CXX_EXTENSIONS OFF)
    Tasmanian_rpath_target(TARGET Tasmanian_${_tsg_exec} USE_CURRENT COMPONENTS SparseGrids DREAM)
    target_link_libraries(Tasmanian_${_tsg_exec} Tasmanian_addons Tasmanian_libdream)
endforeach()
unset(_tsg_exec)

# cheap models have huge random variation in time-per-sample which can cause tests to fail
# make sure other tests are not holding resources and making things even worse
set_tests_properties(${Tasmanian_addons_tests} PROPERTIES RUN_SERIAL ON)
Tasmanian_set_test_properties(TESTS ${Tasmanian_addons_tests})

# Windows specific support (DLL export/import directives and names)
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    if (TARGET Tasmanian_caddons)
        set_target_properties(Tasmanian_caddons PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()
    if (BUILD_SHARED_LIBS)
        set(Tasmanian_MSVC_PATH_STRING "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Release;${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Debug")
        set(Tasmanian_MSVC_PATH_STRING "${Tasmanian_MSVC_PATH_STRING};${CMAKE_CURRENT_BINARY_DIR}/../DREAM/Release;${CMAKE_CURRENT_BINARY_DIR}/../DREAM/Debug;$ENV{PATH}")
        string(REPLACE ";" "\\;" Tasmanian_MSVC_PATH_STRING "${Tasmanian_MSVC_PATH_STRING}")
        set_tests_properties(${Tasmanian_addons_tests} PROPERTIES ENVIRONMENT "PATH=${Tasmanian_MSVC_PATH_STRING}")
    endif()
endif()

# install directives
target_include_directories(Tasmanian_addons INTERFACE $<INSTALL_INTERFACE:include>)
get_target_property(_tsg_sources Tasmanian_addons INTERFACE_SOURCES)
install(FILES ${_tsg_sources} DESTINATION include)
install(TARGETS Tasmanian_addons EXPORT "${Tasmanian_export_name}" PUBLIC_HEADER DESTINATION include)

# cleanup
unset(_tsg_sources)
unset(Tasmanian_addons_executables)
unset(Tasmanian_addons_tests)

=== DREAM/CMakeLists.txt ===
########################################################################
# DREAM librareis and command line tool
########################################################################

add_library(Tasmanian_libdream  TasmanianDREAM.hpp
                                tsgDreamState.hpp
                                tsgDreamState.cpp
                                tsgDreamSample.hpp
                                tsgDreamSampleWrapC.cpp
                                tsgDreamLikelihoodCore.hpp
                                tsgDreamLikelyGaussian.hpp
                                tsgDreamLikelyGaussian.cpp
                                tsgDreamCoreRandom.hpp
                                tsgDreamCorePDF.hpp
                                tsgDreamEnumerates.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/TasmanianOptimization.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/TasmanianOptimizationWrapC.cpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgParticleSwarm.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgParticleSwarm.cpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgGradientDescent.hpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgGradientDescent.cpp
                                ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tsgOptimizationUtils.hpp)

target_include_directories(Tasmanian_libdream PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)
target_link_libraries(Tasmanian_libdream  Tasmanian_libsparsegrid)

set_target_properties(Tasmanian_libdream PROPERTIES OUTPUT_NAME "tasmaniandream"
                                                    SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                    VERSION   ${PROJECT_VERSION})
Tasmanian_rpath_target(TARGET Tasmanian_libdream COMPONENTS SparseGrids)

if (Tasmanian_ENABLE_OPENMP)
    target_compile_options(Tasmanian_libdream PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${OpenMP_CXX_FLAGS}>)
endif()

install(TARGETS Tasmanian_libdream EXPORT "${Tasmanian_export_name}")


########################################################################
# add dreamtest and examples executables
########################################################################
add_executable(Tasmanian_dreamtest dreamtest_main.cpp
                                   tasdreamExternalTests.hpp
                                   tasdreamExternalTests.cpp
                                   ${CMAKE_CURRENT_SOURCE_DIR}/Optimization/tasdreamOptimizationTests.cpp)

set_target_properties(Tasmanian_dreamtest  PROPERTIES OUTPUT_NAME "dreamtest"
                                                      CXX_EXTENSIONS OFF)
Tasmanian_rpath_target(TARGET Tasmanian_dreamtest USE_CURRENT COMPONENTS SparseGrids)
target_link_libraries(Tasmanian_dreamtest  Tasmanian_libdream)


########################################################################
# Testing
########################################################################
add_test(DreamAnalytic dreamtest analytic)
add_test(DreamModel dreamtest posterior)
add_test(Optimization dreamtest optimization)
Tasmanian_set_test_properties(TESTS DreamAnalytic DreamModel)


########################################################################
# Windows specific support (DLL export/import directives and names)
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

    foreach(_tsg_target libdream dreamtest)
        target_compile_definitions(Tasmanian_${_tsg_target} PRIVATE -D_SCL_SECURE_NO_WARNINGS)
    endforeach()
    unset(_tsg_target)

    if (BUILD_SHARED_LIBS)
        set_target_properties(Tasmanian_libdream PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)

        set(Tasmanian_MSVC_PATH_STRING "${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Release;${CMAKE_CURRENT_BINARY_DIR}/../SparseGrids/Debug;$ENV{PATH}")
        string(REPLACE ";" "\\;" Tasmanian_MSVC_PATH_STRING "${Tasmanian_MSVC_PATH_STRING}")
        set_tests_properties(DreamAnalytic DreamModel Optimization PROPERTIES ENVIRONMENT "PATH=${Tasmanian_MSVC_PATH_STRING}")
    endif()

endif()

########################################################################
# Install headers and config files
########################################################################
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
        DESTINATION include
        FILES_MATCHING PATTERN "*.hpp"
        PATTERN "*.windows.*" EXCLUDE
        PATTERN "*.in.*" EXCLUDE
        PATTERN "Examples" EXCLUDE)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Optimization/"
        DESTINATION include
        FILES_MATCHING PATTERN "*.hpp"
        PATTERN "*.windows.*" EXCLUDE
        PATTERN "*.in.*" EXCLUDE
        PATTERN "Examples" EXCLUDE)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Examples/"
        DESTINATION "share/Tasmanian/examples/"
        FILES_MATCHING PATTERN "*.cpp"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== InterfaceSwig/CMakeLists.txt ===
if (Tasmanian_ENABLE_SWIG)
    find_package(SWIG COMPONENTS fortran REQUIRED)

    # SWIG is requested and available; make sure it's the Fortran fork.
    cmake_policy(SET CMP0078 "NEW")
    cmake_policy(SET CMP0086 "NEW")
    include(UseSWIG)
endif()

set(Tasmanian_GENERATE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/generated")

# usage: Tasmanian_set_fortran_props(TARGET Tasmanian_libdream OUTPUT_NAME "tasmanianfortran")
# sets the common properties of Tasmanian Fortran targets
macro(Tasmanian_set_fortran_props)
    cmake_parse_arguments(Tasmanian_fprop "" "TARGET;OUTPUT_NAME" "" ${ARGN})
    target_link_libraries(${Tasmanian_fprop_TARGET} Tasmanian_addons)
    set_target_properties(${Tasmanian_fprop_TARGET} PROPERTIES
                                                    OUTPUT_NAME ${Tasmanian_fprop_OUTPUT_NAME}
                                                    INSTALL_RPATH "${Tasmanian_rpath}"
                                                    SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                    VERSION   ${PROJECT_VERSION})
    target_include_directories(${Tasmanian_fprop_TARGET} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/>)

    if (Tasmanian_ENABLE_MPI)
        # see the comments in the Addons/CMakeLists.txt
        target_link_libraries(${Tasmanian_fprop_TARGET} MPI::MPI_Fortran)
    endif()

    unset(Tasmanian_fprop_TARGET)
    unset(Tasmanian_fprop_OUTPUT_NAME)
endmacro()

function(tasmanian_add_swig_module tsg_name)
#
# Generates the wrappers using SWIG
#
    # SWIG is available; actually generate the library dynamically.
    set(src_file "${CMAKE_CURRENT_SOURCE_DIR}/${tsg_name}.i")
    # We're using C++
    set_property(SOURCE "${src_file}" PROPERTY CPLUSPLUS ON)
    # We need to include the source directory
    set_property(SOURCE "${src_file}" PROPERTY USE_TARGET_INCLUDE_DIRECTORIES ON)

    # Create the library (testing the generated wrappers)
    swig_add_library(${tsg_name}
      LANGUAGE Fortran
      TYPE USE_BUILD_SHARED_LIBS
      OUTPUT_DIR "${Tasmanian_GENERATE_DIR}"
      SOURCES "${src_file}" ${ARGN}
    )

    Tasmanian_set_fortran_props(TARGET ${tsg_name} OUTPUT_NAME ${tsg_name})

endfunction()

macro(Tasmanian_macro_add_libdfortran03)
#
# Build the Fortran module from an existing generated source file
#   - there is a hack here that adds a new methods inside the TasmanianSparseGrid class
#   - the generated files are read, then modified, then written to a "regenerated" folder
#   - only the updated files are compiled
#   - the original SWIG modules all have _swig in their names, the regenerated ones don't

    file(READ "${Tasmanian_GENERATE_DIR}/tasmanian_swig.f90" Tasmanian_generated_f90)
    string(REPLACE "module tasmanian_swig" "module tasmanian" Tasmanian_generated_f90 ${Tasmanian_generated_f90})
    string(REPLACE " type, public :: TasmanianSparseGrid
  type(SwigClassWrapper), public :: swigdata
 contains"
    "type, public :: TasmanianSparseGrid
  type(SwigClassWrapper), public :: swigdata
 contains
    procedure :: returnPoints => tsgGetPoints
    procedure :: returnLoadedPoints => tsgGetLoadedPoints
    procedure :: returnNeededPoints => tsgGetNeededPoints
    procedure :: returnQuadratureWeights => tsgGetQuadratureWeights

    procedure :: returnHierarchicalCoefficients => tsgGetHierarchicalCoefficients
    procedure :: returnComplexHierarchicalCoefficients => tsgGetComplexHierarchicalCoefficients
    procedure :: setComplexHierarchicalCoefficients => tsgSetComplexHierarchicalCoefficients
    "
    Tasmanian_generated_f90 ${Tasmanian_generated_f90})

    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian.f90" "${Tasmanian_generated_f90}")

    add_library(Tasmanian_libfortran03  "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian.f90"
                                        "${Tasmanian_GENERATE_DIR}/tasmanian_swigFORTRAN_wrap.cxx")

    Tasmanian_set_fortran_props(TARGET Tasmanian_libfortran03 OUTPUT_NAME "tasmanianfortran")
    Tasmanian_rpath_target(TARGET Tasmanian_libfortran03)

    install(TARGETS Tasmanian_libfortran03 EXPORT "${Tasmanian_export_name}")

    if (Tasmanian_ENABLE_MPI)
        file(READ "${Tasmanian_GENERATE_DIR}/tasmanian_mpi_swig.f90" Tasmanian_generated_f90)
        string(REPLACE "module tasmanian_mpi_swig" "module tasmanian_mpi" Tasmanian_generated_f90 ${Tasmanian_generated_f90})
        string(REPLACE "use tasmanian_swig" "use tasmanian" Tasmanian_generated_f90 ${Tasmanian_generated_f90})

        file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian_mpi.f90" "${Tasmanian_generated_f90}")

        add_library(Tasmanian_libfortranmpi03  "${CMAKE_CURRENT_BINARY_DIR}/regenerated/tasmanian_mpi.f90"
                                               "${Tasmanian_GENERATE_DIR}/tasmanian_mpi_swigFORTRAN_wrap.cxx")

        Tasmanian_set_fortran_props(TARGET Tasmanian_libfortranmpi03 OUTPUT_NAME "tasmanianfortranmpi")
        Tasmanian_rpath_target(TARGET Tasmanian_libfortranmpi03)
        target_link_libraries(Tasmanian_libfortranmpi03  Tasmanian_libfortran03)

        install(TARGETS Tasmanian_libfortranmpi03 EXPORT "${Tasmanian_export_name}")

        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tasmanian_mpi.mod"
                DESTINATION include
                PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
    endif()

endmacro()

########################################################################
# Fortran librareis and command line tools
########################################################################

add_executable(Tasmanian_fortran_swig_tester ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/fortranswigtester.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_common.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_make_grid.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_domain.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_evaluate.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_update_grid.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_refinement.f90
                                             ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_hierarchy.f90
                                             )
set_target_properties(Tasmanian_fortran_swig_tester PROPERTIES OUTPUT_NAME "forswigtester")
Tasmanian_set_fortran_linker(TARGET Tasmanian_fortran_swig_tester)

if (Tasmanian_ENABLE_SWIG)
    # generate the interface
    tasmanian_add_swig_module(tasmanian_swig)
    if (Tasmanian_ENABLE_MPI)
        tasmanian_add_swig_module(tasmanian_mpi_swig)
        target_link_libraries(tasmanian_mpi_swig  tasmanian_swig)
    endif()
endif()

Tasmanian_macro_add_libdfortran03()

target_link_libraries(Tasmanian_fortran_swig_tester  Tasmanian_libfortran03)

add_test(Fortran2003 forswigtester)
Tasmanian_set_test_properties(TESTS Fortran2003)
Tasmanian_rpath_target(TARGET Tasmanian_fortran_swig_tester USE_CURRENT COMPONENTS SparseGrids DREAM)

if (Tasmanian_ENABLE_MPI)
    add_executable(Tasmanian_fortran_mpiswig_tester ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/mpitester.f90
                                                    ${CMAKE_CURRENT_SOURCE_DIR}/FortranTests/test_common.f90
                                                    )
    set_target_properties(Tasmanian_fortran_mpiswig_tester PROPERTIES OUTPUT_NAME "mpiforswigtester")
    Tasmanian_rpath_target(TARGET Tasmanian_fortran_mpiswig_tester USE_CURRENT COMPONENTS SparseGrids DREAM)
    Tasmanian_set_fortran_linker(TARGET Tasmanian_fortran_mpiswig_tester)

    target_link_libraries(Tasmanian_fortran_mpiswig_tester  Tasmanian_libfortranmpi03)

    add_test(MPIFortran2003 ${MPIEXEC_EXECUTABLE} ${MPIEXEC_NUMPROC_FLAG} 3 ${MPIEXEC_PREFLAGS} ${CMAKE_CURRENT_BINARY_DIR}/mpiforswigtester ${MPIEXEC_POSTFLAGS})
    set_tests_properties(MPIFortran2003 PROPERTIES RUN_SERIAL ON)
    Tasmanian_set_test_properties(TESTS MPIFortran2003)
endif()

########################################################################
# Installation
########################################################################

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tasmanian.mod"
        DESTINATION include
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/FortranExamples/"
        DESTINATION "share/Tasmanian/examples/"
        FILES_MATCHING PATTERN "*.f90"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== SparseGrids/CMakeLists.txt ===
########################################################################
# Sparse Grid libraries and gridtest command line tool
########################################################################

########################################################################
# Define source files
# in order to avoid GLOB, list all source files for add_library()
########################################################################
# source files specific to cuda/hip, used for both static and shared libs
set(Tasmanian_source_libsparsegrid_cuda
       ${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgCudaWrappers.cpp
       tsgCudaKernels.cu)
set(Tasmanian_source_libsparsegrid_hip
       ${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgHipWrappers.cpp
       tsgHipKernels.hip.cpp)

set(Tasmanian_sparse_grid_null_backend ON)
if (Tasmanian_ENABLE_CUDA OR Tasmanian_ENABLE_HIP OR Tasmanian_ENABLE_DPCPP)
    set(Tasmanian_sparse_grid_null_backend OFF)
endif()

add_library(Tasmanian_libsparsegrid
        TasmanianSparseGrid.hpp
        TasmanianSparseGrid.cpp
        TasmanianSparseGridWrapC.cpp
        tsgAcceleratedHandles.hpp
        tsgAcceleratedDataStructures.hpp
        tsgAcceleratedDataStructures.cpp
        tsgCacheLagrange.hpp
        tsgCoreOneDimensional.hpp
        tsgCoreOneDimensional.cpp
        tsgDConstructGridGlobal.hpp
        tsgDConstructGridGlobal.cpp
        tsgCudaLoadStructures.hpp
        tsgEnumerates.hpp
        tsgGridCore.hpp
        tsgGridGlobal.hpp
        tsgGridGlobal.cpp
        tsgGridWavelet.hpp
        tsgGridWavelet.cpp
        tsgHardCodedTabulatedRules.hpp
        tsgHardCodedTabulatedRules.cpp
        tsgGridLocalPolynomial.hpp
        tsgGridLocalPolynomial.cpp
        tsgGridSequence.hpp
        tsgGridSequence.cpp
        tsgGridFourier.hpp
        tsgGridFourier.cpp
        tsgIndexManipulator.hpp
        tsgIndexManipulator.cpp
        tsgHierarchyManipulator.hpp
        tsgHierarchyManipulator.cpp
        tsgIOHelpers.hpp
        tsgIndexSets.hpp
        tsgIndexSets.cpp
        tsgLinearSolvers.hpp
        tsgLinearSolvers.cpp
        tsgOneDimensionalWrapper.hpp
        tsgRuleLocalPolynomial.hpp
        tsgRuleWavelet.hpp
        tsgRuleWavelet.cpp
        tsgSequenceOptimizer.hpp
        tsgSequenceOptimizer.cpp
        tsgMathUtils.hpp
        tsgUtils.hpp
        $<$<BOOL:${Tasmanian_sparse_grid_null_backend}>:${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgGpuNull.cpp>
        $<$<BOOL:${Tasmanian_ENABLE_CUDA}>:${Tasmanian_source_libsparsegrid_cuda}>
        $<$<BOOL:${Tasmanian_ENABLE_HIP}>:${Tasmanian_source_libsparsegrid_hip}>
        $<$<BOOL:${Tasmanian_ENABLE_DPCPP}>:${CMAKE_CURRENT_SOURCE_DIR}/../InterfaceTPL/tsgDpcppWrappers.cpp>
        $<$<BOOL:${Tasmanian_ENABLE_DPCPP}>:${CMAKE_CURRENT_SOURCE_DIR}/tsgDpcppKernels.cpp>
        )

########################################################################
# add the gridtest and examples executables
########################################################################
add_executable(Tasmanian_gridtest gridtest_main.cpp
                                  TasmanianSparseGrid.hpp
                                  gridtestCLICommon.hpp
                                  gridtestExternalTests.hpp
                                  gridtestExternalTests.cpp
                                  gridtestTestHelpers.hpp
                                  gridtestTestFunctions.hpp
                                  gridtestTestFunctions.cpp
                                  gridtestUnitTests.hpp
                                  gridtestUnitTests.cpp
                                  gridtestTestInterfaceC.cpp)

add_executable(Tasmanian_benchmarksgrid  gridtestCLICommon.hpp
                                         Benchmarks/benchCommon.hpp
                                         Benchmarks/benchMakeGrid.hpp
                                         Benchmarks/benchLoadNeeded.hpp
                                         Benchmarks/benchDifferentiate.hpp
                                         Benchmarks/benchEvaluate.hpp
                                         Benchmarks/benchRefine.hpp
                                         Benchmarks/bench_main.cpp)

if (Tasmanian_ENABLE_CUDA)
    # CMake does not automatically add the CUDA include path, any source file that adds <cuda.h> directly or transitively
    # must be labeled as "CUDA" source files and compiled with the nvcc compiler.
    # Beware that the nvcc compiler seems to struggle with some STL algorithms, transitive inclusion of <cuda.h> must be minimized.
    set_source_files_properties(${Tasmanian_source_libsparsegrid_cuda} PROPERTIES LANGUAGE CUDA)
    set_property(TARGET Tasmanian_libsparsegrid PROPERTY CUDA_STANDARD 11)
elseif(Tasmanian_ENABLE_HIP)
    set_source_files_properties(${Tasmanian_source_libsparsegrid_hip} PROPERTIES LANGUAGE HIP)
elseif(Tasmanian_ENABLE_DPCPP)
    target_compile_options(Tasmanian_libsparsegrid PRIVATE -fsycl)
    target_compile_options(Tasmanian_gridtest      PRIVATE -fsycl)
    target_link_options(Tasmanian_libsparsegrid    PRIVATE -fsycl)
    target_link_options(Tasmanian_gridtest         PRIVATE -fsycl)
endif()

target_link_libraries(Tasmanian_libsparsegrid  Tasmanian_dependencies)

target_include_directories(Tasmanian_libsparsegrid PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)

set_target_properties(Tasmanian_libsparsegrid PROPERTIES OUTPUT_NAME "tasmaniansparsegrid"
                                                         SOVERSION ${Tasmanian_VERSION_MAJOR}
                                                         VERSION   ${PROJECT_VERSION})
Tasmanian_rpath_target(TARGET Tasmanian_libsparsegrid)

if (Tasmanian_ENABLE_OPENMP)
    # the nvcc compiler does nor recognize OpenMP, add the flag only to non-CUDA source files
    target_compile_options(Tasmanian_libsparsegrid PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${OpenMP_CXX_FLAGS}>)
endif()

install(TARGETS Tasmanian_libsparsegrid EXPORT "${Tasmanian_export_name}")

foreach(_tsgtarget gridtest benchmarksgrid)
    target_link_libraries(Tasmanian_${_tsgtarget} Tasmanian_libsparsegrid)
    set_target_properties(Tasmanian_${_tsgtarget} PROPERTIES OUTPUT_NAME "${_tsgtarget}" CXX_EXTENSIONS OFF)
    Tasmanian_rpath_target(TARGET Tasmanian_${_tsgtarget} USE_CURRENT)
    if (Tasmanian_ENABLE_OPENMP)
        # the OpenMP libraries are carried transitively from sparse grids library
        target_compile_options(Tasmanian_${_tsgtarget} PRIVATE ${OpenMP_CXX_FLAGS})
    endif()
    if (Tasmanian_ENABLE_HIP)
        target_link_libraries(Tasmanian_${_tsgtarget} hip::host)
    endif()
endforeach()
unset(_tsgtarget)

# data file, needed for testing and reference about custom rule definitions
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/GaussPattersonRule.table"  "${CMAKE_CURRENT_BINARY_DIR}/GaussPattersonRule.table" COPYONLY)


########################################################################
# Windows specific support (DLL export/import directives and names)
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

    foreach(_tsg_target libsparsegrid gridtest)
        # suppresses warnings regarding pointers to the middle of an array
        target_compile_definitions(Tasmanian_${_tsg_target} PRIVATE -D_SCL_SECURE_NO_WARNINGS)
        # needed to prevent crash on using STL vector iterators
        target_compile_definitions(Tasmanian_${_tsg_target} PUBLIC  -D_HAS_ITERATOR_DEBUGGING=0)
    endforeach()
    unset(_tsg_target)

    if (BUILD_SHARED_LIBS)
        set_target_properties(Tasmanian_libsparsegrid PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()

endif()


########################################################################
# Testing
########################################################################
add_test(SparseGridsAcceleration gridtest acceleration -gpuid ${Tasmanian_TESTS_GPU_ID})
add_test(SparseGridsDomain       gridtest domain)
add_test(SparseGridsRefinement   gridtest refinement)
add_test(SparseGridsGlobal       gridtest global)
add_test(SparseGridsLocal        gridtest local)
add_test(SparseGridsWavelet      gridtest wavelet)
add_test(SparseGridsFourier      gridtest fourier)
add_test(SparseGridsExceptions   gridtest errors)
add_test(SparseGridsAPI          gridtest api)
add_test(SparseGridsC            gridtest c)
Tasmanian_set_test_properties(TESTS SparseGridsAcceleration SparseGridsDomain SparseGridsRefinement SparseGridsGlobal SparseGridsLocal SparseGridsWavelet SparseGridsFourier SparseGridsExceptions SparseGridsAPI SparseGridsC)

if (Tasmanian_ENABLE_BLAS)
    add_test(SparseGridsLAPACK gridtest lapack)
    Tasmanian_set_test_properties(TESTS SparseGridsLAPACK)
endif()

########################################################################
# Install headers and config files
########################################################################
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
        DESTINATION include
        FILES_MATCHING PATTERN "*.hpp"
        PATTERN "*.windows.*" EXCLUDE
        PATTERN "Examples" EXCLUDE
        PATTERN "Benchmarks" EXCLUDE
        PATTERN "tsgHiddenExternals.hpp" EXCLUDE)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/TasmanianSparseGrid.h"
        DESTINATION include
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/Examples/"
        DESTINATION "share/Tasmanian/examples/"
        FILES_MATCHING PATTERN "*.cpp"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/GaussPattersonRule.table"
        DESTINATION "share/Tasmanian/"
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

=== Tasgrid/CMakeLists.txt ===
########################################################################
# tasgrid command line tool
########################################################################

########################################################################
# add the tasgrid executable
########################################################################
add_executable(Tasmanian_tasgrid tasgrid_main.cpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestCLICommon.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestExternalTests.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestExternalTests.cpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestTestHelpers.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestTestFunctions.hpp
                                 ${CMAKE_CURRENT_SOURCE_DIR}/../SparseGrids/gridtestTestFunctions.cpp
                                 tasgridWrapper.hpp
                                 tasgridWrapper.cpp)

target_link_libraries(Tasmanian_tasgrid Tasmanian_addons)

set_target_properties(Tasmanian_tasgrid PROPERTIES OUTPUT_NAME "tasgrid" CXX_EXTENSIONS OFF)
Tasmanian_rpath_target(TARGET Tasmanian_tasgrid COMPONENTS SparseGrids DREAM)
if (Tasmanian_ENABLE_OPENMP)
    # the OpenMP libraries are carried transitively from sparse grids library
    target_compile_options(Tasmanian_tasgrid PRIVATE ${OpenMP_CXX_FLAGS})
endif()
if (Tasmanian_ENABLE_HIP)
    target_link_libraries(Tasmanian_tasgrid hip::host)
endif()

########################################################################
# Windows specific support (DLL export/import directives and names)
########################################################################
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

    # suppresses warnings regarding pointers to the middle of an array
    target_compile_definitions(Tasmanian_tasgrid PRIVATE -D_SCL_SECURE_NO_WARNINGS)
    # needed to prevent crash on using STL vector iterators
    target_compile_definitions(Tasmanian_tasgrid PUBLIC  -D_HAS_ITERATOR_DEBUGGING=0)

endif()

########################################################################
# Install binaries and shared objects
########################################################################

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/../configured/tasgridLogs.hpp"
        DESTINATION include
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(TARGETS Tasmanian_tasgrid EXPORT "${Tasmanian_export_name}")

=== debian/changelog ===
tasmanian (8.2-2ubuntu1) resolute; urgency=medium

  * Increase variance test tolerance in testDream to avoid
    FTBFS on amd64v3, arm64, ppc64el and s390x

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 16 Jan 2026 15:02:43 +0000

tasmanian (8.2-2) unstable; urgency=medium

  * python3-tasmanian is now arch:any.
    This is needed because the harcoded path to the dlopen’d shared library is
    multiarch.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 14 Jan 2026 20:34:40 +0100

tasmanian (8.2-1) unstable; urgency=medium

  * New upstream version 8.2
  * python-multiarch.patch: new patch, needed for Python interface
  * d/control: use proper team name in Maintainer field
  * d/control: build depend on dh-sequence-fortran
    dh-sequence-fortran-mod is now deprecated.
  * Libraries are now installed in multi-arch paths
  * Drop “Priority: optional”, since it is now the default
  * Bump Standards-Version to 4.7.3
  * testsuite-i386.patch: patch marked as forwarded upstream

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 28 Dec 2025 11:13:40 +0100

=== debian/control ===
Source: tasmanian
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Build-Depends: debhelper-compat (= 13),
               dh-sequence-fortran,
               dh-sequence-python3,
               cmake,
               libblas-dev,
               liblapack-dev,
               python3-numpy
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/tasmanian
Vcs-Git: https://salsa.debian.org/science-team/tasmanian.git
Homepage: https://github.com/ORNL/TASMANIAN

Package: tasgrid
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command-line interface to the Tasmanian sparse grids library
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package contains an executable that provides a command-line interface to
 the Tasmanian Sparse Grids module. It provides the ability to create and
 manipulate sparse grids, save and load them into files and optionally
 interface with another program via text files.

Package: libtasmaniansparsegrid8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian module for sparse grids
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a shared library that implements a variety of sparse
 grids, i.e. a family of algorithms for constructing multidimensional
 quadrature and interpolation rules using multiple tensor products of one
 dimensional rules with varying degree of precision.
 .
 The Tasmanian Sparse Grids Module implements a variety of grids that fall into
 five major categories: global grids, sequence grids, local polynomial grids,
 wavelet grids and fourier grids.

Package: libtasmaniandream8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian module for drawing samples from an arbitrary probability distribution
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a shared library that implements the DiffeRential
 Evolution Adaptive Metropolis (DREAM), which is a method to draw samples from
 an arbitrary probability distribution defined by an arbitrary non-negative
 function. The DREAM approach is similar to the classical Markov Chain Monte
 Carlo, but it evolves a large number of chains simultaneously which leads to
 better parallelization and (potentially) faster convergence. In addition,
 multiple chains allow for better exploration of the probability domain, which
 is often advantageous when working with multi-modal distributions.
 .
 One of the main applications of DREAM is in the field of Bayesian inference,
 where samples are drawn from a posterior distribution comprised from a
 data-informed likelihood and an arbitrary model. The DREAM module of Tasmanian
 can use Tasmanian Sparse Grids approximation to either the model or the
 likelihood.

Package: libtasmanianfortran8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian sparse grids wrappers for Fortran 2003
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a SWIG wrapper around the Tasmanian C++ module for
 sparse grids, making it easy to call it from Fortran 2003.

Package: libtasmaniancaddons8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian add-ons module
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package contains a shared library that provides various additional
 functionalities not included in the core Tasmanian modules.

Package: libtasmanian-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${fortran:Depends},
         libtasmaniansparsegrid8 (= ${binary:Version}),
         libtasmaniandream8 (= ${binary:Version}),
         libtasmanianfortran8 (= ${binary:Version}),
         libtasmaniancaddons8 (= ${binary:Version})
Description: Tasmanian development files
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides all the necessary development files to use the Tasmanian
 modules either from C++, C or Fortran 2003.

Package: octave-tasmanian
Architecture: all
Depends: ${misc:Depends},
         tasgrid
Recommends: octave
Description: Octave interface to the Tasmanian sparse grids module
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a GNU Octave interface to the Tasmanian sparse grids
 module. This interface can also be used from MATLAB.

Package: python3-tasmanian
# Needs arch:any, because the harcoded path to the dlopen’d shared library is multiarch
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-numpy,
         libtasmanian-dev
Description: Python interface to the Tasmanian sparse grids and DREAM modules
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a Python interface to the Tasmanian sparse grids and
 DREAM modules.

=== debian/tests/control ===
# Example taken from InterfaceCLI.md
Test-Command: tasgrid -mq -dim 4 -depth 2 -type qptotal -1d gauss-legendre -p
Depends: tasgrid

# Segfaults on riscv64 as of version 8.1-3
Tests: interface-cplusplus
Depends: libtasmanian-dev, g++
Restrictions: allow-stderr
Architecture: !riscv64

Tests: interface-fortran-2003
Depends: libtasmanian-dev, gfortran
Restrictions: allow-stderr

# Segfaults on riscv64 as of version 8.1-3
Test-Command: octave-cli --eval "addpath /usr/share/Tasmanian/matlab; tsgExample"
Depends: octave-tasmanian, octave
Restrictions: allow-stderr
Architecture: !riscv64

# Segfaults on riscv64 as of version 8.1-3
Tests: interface-python
Depends: python3-tasmanian
Restrictions: allow-stderr
Architecture: !riscv64
